import testCafeCore from '../../deps/testcafe-core';
import DragAutomationBase from './base';
import { getOffsetOptions } from '../../../../shared/actions/utils/offsets';

const positionUtils = testCafeCore.positionUtils;


export default class DragToElementAutomation extends DragAutomationBase {
    constructor (element, destinationElement, dragToElementOptions) {
        super(element, dragToElementOptions);

        this.destinationElement = destinationElement;
        this.destinationOffsetX = dragToElementOptions.destinationOffsetX;
        this.destinationOffsetY = dragToElementOptions.destinationOffsetY;
    }

    async _getDestination () {
        const element     = this.destinationElement;
        const elementRect = positionUtils.getElementRectangle(element);
        const offsets     = await getOffsetOptions(element, this.destinationOffsetX, this.destinationOffsetY);

        const endPoint = {
            x: elementRect.left + offsets.offsetX,
            y: elementRect.top + offsets.offsetY,
        };

        return { element, offsets, endPoint };
    }
}
